/*!
 * sign.dll ControlAddIn v1.0
 *
 * Copyright 2018 Geert Rozendom, Newminds
 * Released under the MIT license
 *
 * General method for creating a control AddIn is from Vjeko. Thanks, Vjeko!:
 * http://vjeko.com/tags/control-add-in/
 *
 * Javascript lib for creating a nice signature is from Szymon Nowak
 * https://github.com/szimek/signature_pad
 *
 * http://newminds.nl/
 *
 */

function MethodCall(request) {
    switch (request.method) {
        case "start":
            start();
            break;
        case "save":
            save();
            break;
        case "clear":
            clear();
            break;
        default: 
            doDefault(request.method);
    }
};

function start() {
    var wrapper = document.getElementById("controlAddIn");
    var canvas = document.createElement("canvas");
    canvas.id = 'theCanvas';
    wrapper.appendChild(canvas);
    signaturePad = new SignaturePad(canvas, {
        backgroundColor: 'rgb(255, 255, 255)'
    });
    
    window.onresize = resizeCanvas;
    resizeCanvas();    
};

function clear() {
    signaturePad.clear();
    resizeCanvas();
};

function save() {
    if (signaturePad.isEmpty()) {
        nav("error","nosignature");
    } else {
        var dataURL = signaturePad.toDataURL("image/png");
        nav("signature",dataURL);
    }
};

function doDefault(theCommand) {
    alert("received unknown command: " + theCommand );
};

function raiseAddInReady() {
    Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("ControlReady", []);
};

function nav(event,arguments) {
    Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("ControlEvent", [
        {
            Event: event,
            Arguments: arguments
        }
    ]);

};

function resizeCanvas() {
    var ratio = Math.max(window.devicePixelRatio || 1, 1);
    var canvas = document.getElementById("theCanvas");
    canvas.width = canvas.offsetWidth * ratio;
    canvas.height = canvas.offsetHeight * ratio;
    canvas.getContext("2d").scale(ratio, ratio);
}

var signaturePad;
window.onerror = function(msg, url, line, col, error) {
    var extra = !col ? '' : '\ncolumn: ' + col;
    extra += !error ? '' : '\nerror: ' + error;
    nav("error","Error: " + msg + "\nurl: " + url + "\nline: " + line + extra);
    var suppressErrorAlert = true;
    return suppressErrorAlert;
};